#! python3
# docx練習

from docx import Document
from docx.shared import Cm
from docx.shared import Pt
import openpyxl

#wordファイルオブジェクトを生成
document = Document('template.docx')


#エクセルファイルを読み込み
wb = openpyxl.load_workbook('setting.xlsx')
sheet1 = wb['Sheet1']

#設定値
c = sheet1['B2'].value #役名部分の文字数
h = sheet1['B3'].value #せりふ部分の文字数
indent = 4 - (h - 19)*4/10 #インデント（役名の上の余白）
kaishigyo = -1 +  sheet1['B4'].value #せりふが始まる行数
gikyoku_title = sheet1['B5'].value + '.txt'


#戯曲テキストファイルを読み込み
gikyoku_file = open(gikyoku_title)
lines = gikyoku_file.readlines()

#word側に記述（せりふより前のブロック）
for j in range(1,kaishigyo):
    line = lines[j].replace('\n','')
    paragraph = document.add_paragraph(line)

#word側に記述（一行あける）
paragraph = document.add_paragraph()


#word側に記述（せりふブロック）
for i in range(kaishigyo, len(lines)):
    line = lines[i].split('　')  #ある行の役名とせりふを（スペース）で分割して役名を取得
    serif_len = len(lines[i]) - len(line[0])    #せりふの文字数を取得
    cast = line[0].ljust(c, '　')    #役名部分が上で設定した文字数になるようにスペースを追加
    c_moji = len(line[0])+1     #役名の文字数＋１
    serif = lines[i][c_moji:c_moji+h]   #せりふ部分の文字列の最初の一行を取得
    x = 1 #カウンタ

    #せりふの2行目以降を取得
    while serif_len > h:
        serif = serif + '\n' + '　'*c + lines[i][c_moji+h*x:c_moji+(h*(x+1))]
        x = x + 1
        serif_len = serif_len -h

    #役名とせりふをWord側に記述
    text = cast + serif
    paragraph = document.add_paragraph(text)
    paragraph.paragraph_format.left_indent = Cm(indent)



'''
line = lines[kaishigyo].split('　')
serif_len = len(lines[kaishigyo]) - len(line[0])
print(len(lines[kaishigyo]))
print(len(line[0]))
print(serif_len)
'''

#wordを書き出して保存
seikeizumi = sheet1['B5'].value + '-seikei.docx'
document.save(seikeizumi)

print('書き出し完了')
